#!/umr/bin/perl
#Author:  Gregory Jaromack
#Discription:  This script will ask the teacher how many students the
#	       teacher wants to add and and adds the students if there
#	       is still room in the range of numbers from 001 to 999

#last update: 04/30/2001
#file name: addstudent.pl

#Expected I/O: Inputs: $numstu, $Fname, $Lname
#	       Outputs: $User_Id, $Fname, $Lname, $Password

#Database interaction: pulling info from tables: S_User_Id, Teaches, 
#	               T_User_Id
#		       inputing into tables: Student, Teaches

#sub routine to add leading zeros onto a number
sub numtext
{

	my($val);
	my($digits);
	my($loop);
	my($result);
	my($remainder);

	($val, $digits) = @_;
	$remainder = $val;
	$result = "";
	for ($loop=0;$loop<$digits;$loop++)
	{
		$result = (int $remainder%10).$result;
		$remainder = int $remainder/10;
	}

	return $result;
}

#used for database
use lib "/afs/umr.edu/software/umrperl/libs";
use UMR::OracleObject;
use UMR::HTMLUtil;

require "geometry_funcs.pl";

# Initialize %rqpairs with submitted variables
&HTMLGetRequest;

# Check variable "mode" to decide what the script should do
$mode=$rqpairs{"mode"};

#displays the first html page which the teacher enters in the number
#of students they wish to enter.
unless ($mode)
{
 get_cookies();
 $username=$cookies{"geometry_username"};
 $password=$cookies{"geometry_password"};
 
 get_oracle_auth();
 
 $oradb = new UMR::OracleObject;

 unless ($oradb->SQL_OpenDatabase ($tnsname, %orainfo))
 {
  &HTMLContentType;
  display_HTML_header($title); 
  $oradb->SQL_Error ("Can't open database");
  display_HTML_footer();
  exit;
 }

 if (is_teacher($username,$password) ne 1)
 {
  &HTMLContentType;
  display_HTML_header($title);
  print "Invalid login.<BR>\n";
  display_HTML_footer();
  exit;
 }


 &HTMLContentType;
 $title="Add Students";
 display_HTML_header($title);
 
 &HTMLStartForm(&HTMLScriptURL);
 print "\n";
 &HTMLHidden("mode","student_data");
 print "\n";
 print "Enter Number of Students to Add: ";
 &HTMLInputText("number",3,"1");
 print "<BR>\n";
 print "<BR>\n";
 &HTMLSubmit("Submit");
 &HTMLEndForm;
 print "\n";
 display_HTML_footer();
}

#if mode = "student_data", will diplay this page which the teacher will
#enter in the required information about the student
if ($mode eq "student_data")
{
 get_cookies();
 $username=$cookies{"geometry_username"};
 $password=$cookies{"geometry_password"};
 
 get_oracle_auth();
 
 $oradb = new UMR::OracleObject;

 unless ($oradb->SQL_OpenDatabase ($tnsname, %orainfo))
 {
  &HTMLContentType;
  display_HTML_header($title); 
  $oradb->SQL_Error ("Can't open database");
  display_HTML_footer();
  exit;
 }

 if (is_teacher($username,$password) ne 1)
 {
  &HTMLContentType;
  display_HTML_header($title);
  print "Invalid login.<BR>\n";
  display_HTML_footer();
  exit;
 }

 &HTMLContentType;
 $title="Add Students";
 display_HTML_header($title);
 
# get_oracle_auth();

# $oradb = new UMR::OracleObject;
# $oradb -> SQL_OpenDatabase ($tnsname, %orainfo) ||
#	$oradb -> SQL_Error ("Can't open database");

 #print "Connection to the database is successfull.\n";

 #teacher user_id
 $Teacher = $username;
 $quoted_Teacher = $oradb->SQL_QuoteString($Teacher);

 #number of students to add
 $numstu = $rqpairs{"number"};

 if ($numstu == 0)
 {
   print "Cannot add ZERO students\n";
   exit;
 }
 
 #find last stu id for a particular teacher
 $qry = "SELECT S_User_Id FROM TEACHES WHERE T_User_Id = 
	 $quoted_Teacher ORDER BY S_User_Id";
 $cid = $oradb->SQL_OpenQuery($qry) or 
	$oradb->SQL_Error && die "query failed";

 #used to count how many students are in the Data Base
 $no_students=1;

 #while loop used to copy the tables into an array
 while(@a_row=$oradb->SQL_FetchRow($cid))
 {
	#indicates the teacher has at least one student
	$no_students=0;
	#records the last student's userid
	$last_student = $a_row[0];
	#print "$last_student\n";
 }

 $oradb -> SQL_CloseQuery($cid);

 if($no_students eq 1)
 {
	#there are no students and can start at 001
	$val='000';
	$val=numtext($val,3);
 }

 else
 {
 	#splits what's in a_row[0] into parts by a '-' and stores it into an array
	@parts = split('-',$last_student);
	$val = $parts[1];
 }

 $checkval = $val + $numstu;
 $checkval = 999 - $checkval;

 #used to reset $val into a number xxx
 $val = numtext($val,3);

 #checks to see if there is room to add more students
 if($checkval >= 0)
 {
	#entering the new students into the database
	print "Enter in the following information: <BR>\n";
	print "First Name         Last Name         Password<BR>\n<BR>\n";

	&HTMLStartForm(&HTMLScriptURL);
	print "\n";
	&HTMLHidden("mode","submit");
	print "\n";
	&HTMLHidden("val","$val");
	print "\n";
	&HTMLHidden("Teacher","$Teacher");
	print "\n";
	&HTMLHidden("Students","$numstu");
	print "\n";

	#for loop to add the students into the database
	for($i=0;$i<$numstu;$i++)
	{
		$val = $val + 1;
		$val = numtext($val,3);
		$User_Id = $Teacher . "-" . $val;
		$Password = "pass$val";

		print "$User_Id &nbsp;&nbsp;";		
		&HTMLInputText("FName_$User_Id",25,"");
		print "&nbsp;&nbsp;";
		&HTMLInputText("LName_$User_Id",25,"");
		print "&nbsp;&nbsp;";
		&HTMLInputText("Password_$User_Id",12,"$Password");
		print "<BR>\n";
	}

	print "<BR>\n";
	print "<BR>\n";
	&HTMLSubmit("Submit");
	&HTMLEndForm;
 }

 else
 {
	print "Can't add specified number of students.  Please delete some
		old students.\n";
 }

 print "\n";
 display_HTML_footer(); 
}

#if mode = "submit" this page will insert the student information into the
#database and display on the page what information was inserted
if ($mode eq "submit")
{
 get_cookies();
 $username=$cookies{"geometry_username"};
 $password=$cookies{"geometry_password"};
 
 get_oracle_auth();
 
 $oradb = new UMR::OracleObject;

 unless ($oradb->SQL_OpenDatabase ($tnsname, %orainfo))
 {
  &HTMLContentType;
  display_HTML_header($title); 
  $oradb->SQL_Error ("Can't open database");
  display_HTML_footer();
  exit;
 }

 if (is_teacher($username,$password) ne 1)
 {
  &HTMLContentType;
  display_HTML_header($title);
  print "Invalid login.<BR>\n";
  display_HTML_footer();
  exit;
 }

 &HTMLContentType;
 $title="Add Students";
 display_HTML_header($title);
 
# get_oracle_auth();

# $oradb = new UMR::OracleObject;
# $oradb -> SQL_OpenDatabase ($tnsname, %orainfo) ||
#	$oradb -> SQL_Error ("Can't open database");

 #print "Connection to the database is successfull.\n";
 
  $val = $rqpairs{"val"};
#  $Teacher = $rqpairs{"Teacher"};
  $Teacher = $username;
  $numstu = $rqpairs{"Students"};

 
	#for loop to add the students into the database
	for($i=0;$i<$numstu;$i++)
	{
		$val = $val + 1;
		$val = numtext($val,3);
		$User_Id = $Teacher . "-" . $val;
				
		$Fname = $rqpairs{"FName_$User_Id"};
		$Lname = $rqpairs{"LName_$User_Id"};
		$Password = $rqpairs{"Password_$User_Id"};

		$Fname = $oradb -> SQL_QuoteString($Fname);
		$Lname = $oradb -> SQL_QuoteString($Lname);
		$Password = $oradb -> SQL_QuoteString($Password);
		$qry2 = "INSERT INTO STUDENT VALUES('$User_Id',$Fname, 
			$Lname,$Password)";
		$retval=($oradb -> SQL_ExecQuery($qry2));
if ($retval == 1)
{
	
		$qry3 = "INSERT INTO TEACHES VALUES('$Teacher','$User_Id')";
		$retval=($oradb -> SQL_ExecQuery($qry3));
		
		print "Added User ID $User_Id for $Lname, $Fname with password $Password<BR>\n";
}
else
{
 print "Falied to add User ID $User_Id<BR>\n";
}
	} 
 
display_HTML_footer(); 
}



