#!/umr/bin/perl

#################################################################
# UPDATE TEACHER EMAIL OPTIONS                                  #
# Last updated 4/28/01                                          #
# a portion by Gary Dunaway (with a LOT of help from others)    #
#################################################################
# This script prints an html form. The user_id is read from a   #
# cookie on the users machine.                                  #
# The script accesses the Teacher Table on the user_id to       #
# retreive the information displayed in the form, namely the    #
# values in the EMAIL and EMAIL_OPT fields.                     #
# The form allows the teacher to select an email notification   #
# option and/or update their email address if the displayed     #
# values are not acceptable.                                    #
# If any changes to the EMAIL and EMAIL_OPT fields are detected,#
# it then accesses the teacher table in the database, finds the #
# user id, and updates the table with either or both of the two #
# values that have been changed.                                #
# The form also allows the teacher to have an email sent to them#
# with a complete ordered listing of his/her class and the test #
# status for each student.                                      #
#################################################################


use lib "/afs/umr.edu/software/umrperl/libs";

use UMR::OracleObject;
use UMR::HTMLUtil;

require "geometry_funcs.pl";

$title="E-mail Options";

&HTMLGetRequest;
#&HTMLContentType;
#&HTMLTitle($title);

$mode=$rqpairs{"mode"};
 
get_cookies();
$username=$cookies{"geometry_username"};
$password=$cookies{"geometry_password"};   

get_oracle_auth();
  
$oradb = new UMR::OracleObject;
 
unless ($oradb->SQL_OpenDatabase ($tnsname, %orainfo))
 {
  &HTMLContentType;
  display_HTML_header($title);
  $oradb->SQL_Error ("Can't open database");
  display_HTML_footer();
  exit;
 }
  
 if (is_teacher($username,$password) ne 1)
 {
  &HTMLContentType;
  display_HTML_header($title);
  print "Invalid login.<BR>\n";
  display_HTML_footer();
  exit;
 }

# variable assignment
$uid=$username;

# database operations
#$oradb = new UMR::OracleObject;

#$oradb->SQL_OpenDatabase ($tnsname, %orainfo) ||
#$oradb->SQL_Error ("Can't open database");

# clean up this variable
$uid = $oradb->SQL_QuoteString ($uid);

 &HTMLContentType;
 display_HTML_header($title);
 
# retreive this teachers email_opt and email address from the database
$qry="select * from TEACHER where USER_ID=$uid";
$cid=$oradb->SQL_OpenQuery($qry) or $oradb->SQL_Error && die "select * from teacher query failed";
@a_row = $oradb->SQL_FetchRow($cid);

# variable assignment
$e_addy = @a_row[4];
chomp($e_addy);
$when = @a_row[8];
chomp($when);

# close the database
$oradb->SQL_CloseQuery($cid);


unless ($mode)
{
# if the current e-mail option != pass then print this html doc with "not at all" radio button selected
 if($when ne "pass")
 {
  # the folowing lines print the html document
  print "This page displays the e-mail preferences for your user ID that are currently in the database.\n";
  print "<BR><BR>\n";
  print "<B><U>ANY</U></B> changes you make to the selected e-mail options or displayed e-mail address\n";
  print "<BR>\n";
  print "will update your preferences in the database when the submit button is pressed.\n";
  print "<BR><BR>\n";
  print "You may also choose to have an e-mail sent immediately. This e-mail will contain\n";
  print "<BR>\n";
  print "a complete list of all students in your class that have taken a practice test.\n";
  print "<BR>\n";
  print "It will contain dates and results for all practice tests and actual tests taken by the student.\n";
  print "<BR><BR>\n";
  print "Whether or not you make any changes, press the submit button when you are ready to proceed.\n";
  print "<BR><BR>\n";

  &HTMLStartForm(&HTMLScriptURL);
  print "\n";
 
  &HTMLHidden("mode","query");
  print "\n";

  &HTMLRadioButton("often","pass",0,"E-mail sent after each test has been passed.");

  print "<BR>\n";

  &HTMLRadioButton("often","none",1,"Not at all");

  print "<BR><BR>\n";

  print "E-mail Address: ";
  &HTMLInputText("addy",25,$e_addy);

  print "<BR><BR>\n";

	print "E-mail complete class roster with test results now?";

	print "<BR>\n";

  &HTMLRadioButton("mail_it","do",0,"Yes");

	print "<BR>\n";
	
	&HTMLRadioButton("mail_it","dont",1,"No");

  print "<BR><BR>\n";

	print "Please press the Submit Button only once.";

	print "<BR>\n";

  &HTMLSubmit("Submit");

  print "\n";

  &HTMLEndForm;

  print "\n";
	}

# else the current e-mail option != none so print this html doc with "on every pass" radio button selected
 else
 {
  print "This page displays the e-mail preferences for your user ID that are currently in the database.\n";
  print "<BR><BR>\n";
  print "<B><U>ANY</U></B> changes you make to the selected e-mail options or displayed e-mail address\n";
  print "<BR>\n";
  print "will update your preferences in the database when the submit button is pressed.\n";
  print "<BR><BR>\n";
  print "You may also choose to have an e-mail sent immediately. This e-mail will contain\n";
  print "<BR>\n";
  print "a complete list of all students in your class that have taken a practice test.\n";
  print "<BR>\n";
  print "It will contain dates and results for all practice tests and actual tests taken by the student.\n";
  print "<BR><BR>\n";
  print "Whether or not you make any changes, press the submit button when you are ready to proceed.\n";
  print "<BR><BR>\n";

  &HTMLStartForm(&HTMLScriptURL);
  print "\n";
 
  &HTMLHidden("mode","query");
  print "\n";
 
  &HTMLRadioButton("often","pass",1,"E-mail sent after each test has been passed.");

  print "<BR>\n";

  &HTMLRadioButton("often","none",0,"Not at all");

  print "<BR>\n";

  print "<BR>\n";

  print "Email Address: ";
  &HTMLInputText("addy",25,$e_addy);

  print "<BR><BR>\n";

	print "E-mail complete class roster with test results now?";

	print "<BR>\n";

  &HTMLRadioButton("mail_it","do",0,"Yes");

	print "<BR>\n";
	
	&HTMLRadioButton("mail_it","dont",1,"No");

  print "<BR><BR>\n";

	print "Please press the Submit Button only once.";

	print "<BR>\n";

  &HTMLSubmit("Submit");

  print "\n";

  &HTMLEndForm;

  print "\n";
	}
  display_HTML_footer();
}

if($mode eq "query")
{
# variable pairing
 $often=$rqpairs{"often"};
 chomp($often);
 
 $addy=$rqpairs{"addy"};
 chomp($addy);

 $mail_it=$rqpairs{"mail_it"};
 chomp($mail_it);

# clean up these variables
 $when = $oradb->SQL_QuoteString ($when);
 $e_addy = $oradb->SQL_QuoteString ($e_addy);

 # declarations & initialization
 # for use in determining user changes
 $tally=0;
 $a=1;
 $b=2;
 $c=4;

# # database entry data
# $tnsname="ora_cs_test";
 
# function call for database authorization  
# get_oracle_auth(); 

# database operations
# $oradb = new UMR::OracleObject;
 
# $oradb->SQL_OpenDatabase ($tnsname, %orainfo) ||
# $oradb->SQL_Error ("Can't open database");
 
# clean up these variables
 $often = $oradb->SQL_QuoteString ($often);
 $addy = $oradb->SQL_QuoteString ($addy);

 if($often ne $when)
 { 

  # mark this update 

	$tally=$tally+$a;

  $qry="select EMAIL_OPT from TEACHER where USER_ID=$uid";

  $cid=$oradb->SQL_OpenQuery($qry) or $oradb->SQL_Error && die "select EMAIL_OPT from TEACHER where USER_ID=$uid failed";
  $oradb->SQL_CloseQuery($cid);

  # update the email_opt column for the specified user id
  $update_query="UPDATE TEACHER SET EMAIL_OPT=$often WHERE USER_ID=$uid";
  $oradb->SQL_ExecQuery ($update_query) or $oradb->SQL_Error && die "UPDATE TEACHER SET EMAIL_OPT=$often WHERE USER_ID=$uid failed";
 }

 if($addy ne $e_addy)
 { 

  # mark this update 

	$tally=$tally+$b;

  $qry="select EMAIL from TEACHER where USER_ID=$uid";

  $cid=$oradb->SQL_OpenQuery($qry) or $oradb->SQL_Error && die "select EMAIL from TEACHER where USER_ID=$uid failed";
  $oradb->SQL_CloseQuery($cid);

  # update the email column for the specified user id
  $update_query="UPDATE TEACHER SET EMAIL=$addy WHERE USER_ID=$uid";
  $oradb->SQL_ExecQuery ($update_query) or $oradb->SQL_Error && die "UPDATE TEACHER SET EMAIL=$addy WHERE USER_ID=$uid failed";
 } 


 if($mail_it eq "do")

 {

  # mark this update 
	$tally=$tally+$c;

  # subject line
	$subject[0] = '"';
  $subject[1] = BrainTrax;
  $subject[2] = '-- Class Report"';

  # open a file named output to be sent to the email client
  open (output, "|mailx -s @subject $addy ");

	# varable assignment
	$comma=",";
	$spaces="   ";
	$spaces2="                             ";
	$sid="A_very_bad_student_ID_that_I_HOPE_no_one_will_ever_have";

	# print page header to email
	print output "Test Status Report for Your Online Geometry Class\n";
	print output "\n";
	print output "\n";
	print output "Student Name  Student ID     Subject        Grade   Test        Practice\n";
  print output "------------------------------------------------------------------------\n";

  # retreive this students information
  $qry="SELECT S.Lname, S.Fname, S.User_id, E.Subject, E.Test_Status, E.Date_Practice, E.Date_Test FROM Student S, Teaches T, Exam_Record E WHERE T.T_User_Id=$uid AND S.User_Id=T.S_User_Id AND E.S_User_Id=T.S_User_Id ORDER BY S.Lname, E.Subject";
  $cid=$oradb->SQL_OpenQuery($qry) or $oradb->SQL_Error && die "select for email query failed";
  
	# prepare this data for the email
	while ( @a_row = $oradb->SQL_FetchRow($cid) )
	{
	 # print format control
	 $prt=0;

	 # if this is a different student
	 if($sid ne @a_row[2])
	 {
	  # variable assignment
	  $name=@a_row[0].$comma.@a_row[1];# concatenate full name into single string
	  $sid=@a_row[2];
	  $sub=@a_row[3];
	  $stat=@a_row[4];
		# format this variable to fit the email format
		if($stat eq "Not Taken")
		{
		 $stat = "None";
		}
	  $pract=@a_row[5];
	  $test=@a_row[6];

		# email formatting
		print output "\n";

    # print this data to the email
	  printf output "%s%s%s\n",$name,$spaces,$sid;
		printf output "%s%-10s%9s%13s%12s\n",$spaces2,$sub,$stat,$test,$pract;

		# print format control
		$prt=1;
	 }
	 else
	 {
	  # variable assignment
	  $sub=@a_row[3];
	  $stat=@a_row[4];
		# format this variable to fit the email format
		if($stat eq "Not Taken")
		{
		 $stat = "None";
		}
	  $pract=@a_row[5];
	  $test=@a_row[6];
		
		# print this data to the email
	  printf output "%s%-10s%9s%13s%12s\n",$spaces2,$sub,$stat,$test,$pract;
	 }
	 
	}

	# close this query
  $oradb->SQL_CloseQuery($cid);

	# close and send the email
  close (output);

 }

 # variable preparation
 $change = "E-mail sent after each test has been passed";
 if($often==2)
 {
  $change = "Not at all";
 }
  $change = $oradb->SQL_QuoteString ($change);

# inform the user the update(s) was successful
 if($tally == 0)

 {

  print "Email Options have not changed.<BR>\n";

	print "Email Address has not changed.<BR>\n";

	print "Class roster email has not been sent.<BR>\n"; 

 }

 elsif($tally == 1)

 {

  print "Email Options have been updated to $change.<BR>\n";

 }

 elsif($tally == 2)

 {

  print "Email Address has been updated to $addy.<BR>\n";

 }

 elsif($tally == 3)

 {

  print "Email Options have been updated to $change.<BR>\n";

	print "Email Address has been updated to $addy.<BR>\n";

 }

 elsif($tally == 4)

 {

  print "Current class roster with test status has been sent to $addy.<BR>\n";

 }

 elsif($tally == 5)

 {

  print "Email Options have been updated to $change.<BR>\n";

	print "Current class roster with test status has been sent to $addy.<BR>\n";

 }

 elsif($tally == 6)

 {

  print "Email Address has been updated to $addy.<BR>\n";

	print "Current class roster with test status has been sent to $addy.<BR>\n";

 }

 elsif($tally == 7)

 {

  print "Email Options have been updated to $change.<BR>\n";

	print "Email Address has been updated to $addy.<BR>\n";

	print "Current class roster with test status has been sent to $addy.<BR>\n";

 }

 display_HTML_footer();

}
