#!/umr/bin/perl

#examrec.pl
#Vinh Tan Do, cs319
#Discription: this script asks student id in order to look up the student 
#             practice information; it doesn't requires to enter password.
#Filename: examrec.pl



use lib "/afs/umr.edu/software/umrperl/libs";
use UMR::OracleObject;
use UMR::HTMLUtil;
#use HTML Utilities to display GUI

require "geometry_funcs.pl";

$title="Student Practice Test Information";

# Delay in seconds before HTTP-EQUIV Refresh occurs
$http_equiv_refresh_delay=0;

%URLS=
 (
  "AREA AND VOLUME",
   "http://www.umr.edu/~traxdev/testing/student/surfarea_practest.htm",
  "POLYGONS AND THEIR MEASUREMENTS",
   "http://www.umr.edu/~traxdev/testing/student/polygons_practest.htm",
  "TRIG FUNCTIONS",
   "http://www.umr.edu/~traxdev/testing/student/trig_practest.htm"
 );

&HTMLGetRequest;
#&HTMLContentType;
#display_HTML_header($title);
#print "<H3>$title</H3>\n";


  $subject=$ARGV[0];
  $url=$URLS{$subject};


  
  #open the database

  get_oracle_auth();

  $oradb = new UMR::OracleObject;

  unless ($oradb->SQL_OpenDatabase ($tnsname, %orainfo))
  {
   &HTMLContentType;
   display_HTML_header($title);
   $oradb->SQL_Error ("Can't open database");
   display_HTML_footer();
   exit;
  }

#  $oradb->SQL_OpenDatabase ($tnsname, %orainfo) || 
#     $oradb->SQL_Error ("Can't open database");
  #call subroutine get_cookies to retrieve a list of cookies 
  #from HTTP_COOKIE as the keys to corresponding cookie value

  get_cookies();

  $username=$cookies{"geometry_username"};
  $password=$cookies{"geometry_password"};

  $is_student=is_student($username,$password);
  $is_teacher=is_teacher($username,$password);
  unless ($is_student || $is_teacher)
  {
    &HTMLContentType;
    display_HTML_header($title);
    print "Unable to verify credentials<BR>\n";
    display_HTML_footer();
    exit;
  }

   &HTMLContentType;
   print '<DOCTYPE HTML PUBLIC "-//W3C/DTD HTML 4.01 Transitional//EN">';
   print "\n<HTML>\n";
   print "<HEAD>\n";
   print "<TITLE>$title</TITLE>\n";

   print "<META CONTENT=\"$http_equiv_refresh_delay;URL=$url\" HTTP-EQUIV=\"Refresh\">\n";
   print "</HEAD>\n";
   print "<BODY>\n";

  if ($is_student eq 1)
  {
    $username = $oradb->SQL_QuoteString($username);
    $subject = $oradb->SQL_QuoteString($subject);

    $qry = "select s_user_id from exam_record where s_user_id = $username and subject = $subject";  

    $cid=$oradb->SQL_OpenQuery($qry);

    $record_exists=0;
    while (@a_row=$oradb->SQL_FetchRow($cid))
    {
      $record_exists=1;
    }
    $oradb->SQL_CloseQuery($cid);

    if ($record_exists eq 1)
    {
      print "Record already exists.<BR>\n";
#      exit;
    }
    else
    {

      # insert query
      $qry = "INSERT INTO EXAM_RECORD (S_User_Id, Subject, 
                 Test_Status, Date_Practice,
                 Date_Test) VALUES ($username, $subject, 
                 'Not Taken', sysdate, NULL)";
      $oradb->SQL_ExecQuery($qry) or $oradb->SQL_Error && die "query failed\n";
#      print "Sent query \"$qry\" to database\n";
      print "Created Exam Record for $subject Practice Test<BR>\n";
    }
  }

print "<A HREF=\"$url\">Click here for $subject Practice Test</A><BR>\n";

print "</BODY>\n";
print "</HTML>\n";
