#!/umr/bin/perl

use lib "/afs/umr.edu/software/umrperl/libs";

use UMR::OracleObject;
use UMR::HTMLUtil;
use UMR::AuthSrv;

# Test include file common for all Geometry Project scripts

$tnsname="ora_cs_test";
# Uncomment this to move to production Oracle server
#$tnsname="umr";


# sub get_oracle_auth
# Subroutine to provide a temporary solution for retrieving database 
# authentication information.
# Reads username and password from oracle.txt in the current directory.
sub get_oracle_auth
{
#	my $userid = 'brainwks';
#	my $passwd = &AuthSrv_Fetch (instance => 'oracle', user => $userid);
#	@orainfo{'user', 'passwd'} = ($userid, $passwd);
#if ($ENV{REMOTE_HOST} eq 'distortion.cc.umr.edu')
#{ print "PWD: $passwd<p>" }
#	return;
 my($str);
 open(INFIL,"<oracle.txt");
 $str=<INFIL>;
 chomp($str);
 $orainfo{"user"}=$str;
 $str=<INFIL>;
 chomp($str);
 $orainfo{"passwd"}=$str;
 close(INFIL);
}

# sub Display HTML header
# Subroutine to load and display a common HTML header so that the basic 
# look to the web pages will be identical
sub display_HTML_header
{
 my($title);
 my($line);

 ($title)=@_;
 # Load from a file
 print "<DOCTYPE HTML PUBLIC \"-//W3C/DTD HTML 4.01 Transitional//EN\">\n";
 print "<HTML>\n";
 print "<HEAD>\n";
 print "<TITLE>$title</TITLE>\n";
# print "<BASE HREF=\"http://www.umr.edu/~traxdev/testing/\">\n";
 print "</HEAD>\n";
# print "<BODY background=\"http://www.umr.edu/~traxdev/testing/background.jpg\">\n";
 open(SSI,"<../../math/geometry/ssi/body_header.ssi");
 while ($line=<SSI>)
 {
  print $line;
 }
 close(SSI);
# print "<BLOCKQUOTE><BLOCKQUOTE>";#temporary fix
# HTTP 1.1: Cache-Control: no-cache
 print "<TABLE BORDER=0>\n";
 print "<TR><TD> <IMG SRC=\"http://www.umr.edu/~braintrx/math/geometry/pics/clear.gif\"> 
 </TD><TD>\n";

}

sub display_HTML_footer
{
 print "</TD></TR> \n </TABLE> \n";
 open(SSI,"<../../math/geometry/ssi/body_footer.ssi");
 while ($line=<SSI>)
 {
  print $line;
 }
 close(SSI);
 print "</HTML>\n";
}


# sub get_cookies
# Subroutine to retrieve a list of cookies from the environment variable 
# HTTP_COOKIE.
# Can be called at any time, and initializes the hash %cookies with 
# cookie names as keys to the corresponding cookie value.
sub get_cookies
{
 %cookies=();

 my(@cookielist);
 my(@extra_params);
 my($i);
 my($numcookies);
 my(@cookie);
 my($cookiename);
 my($cookievalue);

 # The environment variable HTTP_COOKIE contains a list of semi-colon 
 # separated cookies
 @cookielist=split(';',$ENV{"HTTP_COOKIE"});
 $numcookies=@cookielist;
 for ($i=0;$i<$numcookies;$i++)
 {
  @cookie=split('=',$cookielist[$i]);
  $cookiename=$cookie[0];
  if (@cookie>1)
  {
   ($cookievalue,@extra_parms)=split(' ',$cookie[1]);
  }
  else
  {
   $cookievalue="";
  }
  chomp($cookiename);
  chomp($cookievalue);
  $cookiename=~ s/^ *//;
  $cookievalue=~ s/^ *//;
  $cookiename=~ s/ *$//;
  $cookievalue=~ s/ *$//;

  $cookies{$cookiename}=$cookievalue;
 }
}

# sub set_cookie
# Subroutine to set a session cookie to a particular value
# Must be called before Content-type sent to web browser
# Takes parameters ($cookie_name,$cookie_value)
sub set_cookie
{
 my($cookie_name);
 my($cookie_value);

 ($cookie_name,$cookie_value)=@_;
 # Cookie will be for this session of the client only and will have the 
 # context of the base part of the URL (http://hostname/).
 print "Set-Cookie: $cookie_name=$cookie_value path=/\n";
}

# sub unset_cookie
# Subroutine to eliminate a cookie (or at least the value stored)
# Takes parameter ($cookie_name)
sub unset_cookie
{
 my($cookie_name);

 ($cookie_name)=@_;
 # Sets cookie to ""
 print "Set-Cookie: $cookie_name=\"\" path=/\n";
 # Reportedly needs to add an expiration date in the past to eliminate 
 # the cookie, but this behavior does not seem to be observed
# print "Set-Cookie: $cookie_name=empty path=/ expires=Monday, 01-Jan-1979 00:00:00 GMT\n";
# print "Set-Cookie: $cookie_name=\"\" path=/ expires=Monday, 01-Jan-1979 00:00:00 GMT\n";

}

# sub is_teacher
# Subroutine to determine whether not a given userid/password pair is a
# valid teacher.
# Takes parameters ($username,$password)
# Returns 1 if a valid teacher and 0 otherwise
# Should already be connected to Oralce (uses $oradb)
sub is_teacher
{ 
 my($username);
 my($password);
 my($quoted_username);
 my($quoted_password);
 my($cid);
 my($qry);
 my($is_teacher);
 my(@a_row);

 ($username,$password)=@_;
 $is_teacher=0;
 $quoted_username = $oradb->SQL_QuoteString($username);
 $quoted_password = $oradb->SQL_QuoteString($password);
 $qry="select PASSWORD from TEACHER where user_id = $quoted_username and password = $quoted_password";

 if ($cid=$oradb->SQL_OpenQuery($qry))
 {
  $found=0;
  while ( @a_row = $oradb->SQL_FetchRow($cid) )
  {
   $is_teacher=1;
  }
  $oradb->SQL_CloseQuery($cid);
 }
 
 return $is_teacher;
}
 
# sub is_student
# Subroutine to determine whether not a given userid/password pair is a
# valid student.
# Takes parameters ($username,$password)
# Returns 1 if a valid student and 0 otherwise
# Should already be connected to Oralce (uses $oradb)
sub is_student
{
 my($username);
 my($password);  
 my($quoted_username);
 my($quoted_password);
 my($cid);
 my($qry);
 my($is_student);   
 my(@a_row);
 
 ($username,$password)=@_;
 $is_student=0;
 $quoted_username = $oradb->SQL_QuoteString($username);
 $quoted_password = $oradb->SQL_QuoteString($password);
 $qry="select PASSWORD from STUDENT where user_id = $quoted_username and password = $quoted_password";

 if ($cid=$oradb->SQL_OpenQuery($qry))
 {
  $found=0;
  while ( @a_row = $oradb->SQL_FetchRow($cid) )
  {
   $is_student=1;
  }
  $oradb->SQL_CloseQuery($cid);
 }
 
 return $is_student;
}


1;

