#!/umr/bin/perl

# Test script for Geometry Brain project
# Written by Ryan Lantzer
# Last updated 4/23/01

# Login Script

use lib "/afs/umr.edu/software/umrperl/libs";

use UMR::OracleObject;
use UMR::HTMLUtil;
#&HTMLContentType;

require "geometry_funcs.pl";

$student_menu="http://www.umr.edu/~traxdev/testing/perl_group/student_menu.html";
$student_menu="http://www.umr.edu/~traxdev/testing/GeoMain2.htm";
$student_menu="http://www.umr.edu/~traxdev/testing/Geo.htm";
$teacher_menu="http://www.umr.edu/~traxdev/testing/perl_group/teacher_menu.html";
$teacher_menu="http://www.umr.edu/~traxdev/testing/TeacherMain2.htm";
$teacher_menu="http://www.umr.edu/~traxdev/testing/Teacher.htm";

# Initialize %rqpairs with submitted variables
&HTMLGetRequest;

# Check variable "mode" to decide what the script should do
$mode=$rqpairs{"mode"};


# Provide a form for logging in
# Requires a test cookie to be set to ensure that login cookies can be 
# generated
unless ($mode)
{
 &HTMLContentType;
 $title="Test Login to Geometry Brain";
 display_HTML_header($title);

 get_cookies();
 # Test for cookies and verify that login will be possible before 
 # presenting a form to fill out.
 if ($cookies{"test_cookies"} ne "TRUE")
 {
  print "You must enable cookie support on your web browser to login.<BR>\n";
  display_HTML_footer();
  exit;
 }
 &HTMLStartForm(&HTMLScriptURL);
 print "\n";
 &HTMLHidden("mode","attempt_logon");
 print "\n";
 print "Enter Userid: ";
 &HTMLInputText("username",25,"");
 print "<BR>\n";
 print "Enter  Password: ";
 &HTMLInputPassword("password",25,"");
 print "<BR><BR>\n";
 &HTMLSubmit("Login");
 &HTMLEndForm;
 print "\n";
 display_HTML_footer();
}

# Accepts login parameters and attempts to authenticate the user login
# If authentication is successfull, displays a menu of things to do.
if ($mode eq "attempt_logon")
{
 $password=$rqpairs{"password"};
 chomp($password);
 $username=$rqpairs{"username"};
 chomp($username);

 get_cookies();
 # Test for cookies
 if ($cookies{"test_cookies"} ne "TRUE")
 {
  &HTMLContentType;
  $title="Test Login to Geometry Brain";
  display_HTML_header($title);
  print "You must enable cookie support on your web browser to login.<BR>\n";
  display_HTML_footer();
  exit;
 }

 get_oracle_auth();

 $oradb = new UMR::OracleObject;

 unless ($oradb->SQL_OpenDatabase ($tnsname, %orainfo))
 {
  unset_cookie("geometry_username");
  unset_cookie("geometry_password");
  &HTMLContentType;
  $title="Test Login to Geometry Brain";
  display_HTML_header($title);
  $oradb->SQL_Error ("Can't open database");
  display_HTML_footer();
  exit;
 }

 $quoted_username = $oradb->SQL_QuoteString($username);
 $qry="select PASSWORD from STUDENT where user_id = $quoted_username";

# print "About to send query \"$qry\" to database<BR>\n";

 unless($cid=$oradb->SQL_OpenQuery($qry))
 {
  unset_cookie("geometry_username");
  unset_cookie("geometry_password");
  &HTMLContentType;
  $title="Test Login to Geometry Brain";
  display_HTML_header($title);
  $oradb->SQL_Error ("Query Failed");
  display_HTML_footer();
  exit;
 }

# print "Sent query \"$qry\" to database<BR>\n";
# print "Query Results:<BR>\n";
 $found=0;
 while ( @a_row = $oradb->SQL_FetchRow($cid) )
 {
  $found++;
  $userpass=$a_row[0];
  $num=@a_row;
 # for ($i=0;$i<$num;$i++)
 # {
 #  print $a_row[$i]." ";
 # }
 # print "<BR>\n";
 }
 $oradb->SQL_CloseQuery($cid);

 if ($found > 0)
 {
  if ($password eq $userpass)
  {
   set_cookie("geometry_username",$username);
   set_cookie("geometry_password",$password);
   &HTMLContentType;
   $title="Test Successfully Logged into Geometry Brain";
#   display_HTML_header($title);
   print '<DOCTYPE HTML PUBLIC "-//W3C/DTD HTML 4.01 Transitional//EN">';
   print "\n<HTML>\n";
   print "<HEAD>\n";
   print "<TITLE>$title</TITLE>\n";
   print "<META CONTENT=\"0;URL=$student_menu\" HTTP-EQUIV=\"Refresh\">\n";
#   print "<META CONTENT=\"1;URL=$student_menu\" HTTP-EQUIV=\"Refresh\">\n";
   print "</HEAD>\n";
   print "<BODY>\n";

   print "<A HREF=\"$student_menu\">Click here for menu</A><BR>\n";
#   print "Note: This should be an HTTP EQUIV to bring up a frameset<BR>\n";
#   display_HTML_footer();
   print "</BODY>\n";
   print "</HTML>\n";
#   print "<b>Successfully logged in as a student.</b><BR>\n";
#   student_menu();
  }
  else
  {
   unset_cookie("geometry_username");
   unset_cookie("geometry_password");
   &HTMLContentType;
   $title="Login Failed";
   display_HTML_header($title);
   print "<b>Invalid Login.</b><BR>\n";
   $url=&HTMLScriptURL;
   print "<A HREF=\"$url\">Click here to login again.</A><BR>\n";
#   print "Note: Bad Student Password<BR>\n";
   display_HTML_footer();
   exit;
  }
 }
 else
 {
  $qry="select PASSWORD from TEACHER where user_id = $quoted_username";

#  print "About to send query \"$qry\" to database<BR>\n";

  unless ($cid=$oradb->SQL_OpenQuery($qry))
  {
   unset_cookie("geometry_username");
   unset_cookie("geometry_password");
   &HTMLContentType;
   &HTMLTitle($title);
   $oradb->SQL_Error ("Query Failed");
   exit;
  }

#  print "Sent query \"$qry\" to database<BR>\n";
#  print "Query Results:<BR>\n";
  $found=0;
  while ( @a_row = $oradb->SQL_FetchRow($cid) )
  {
   $found++;
   $userpass=$a_row[0];
   $num=@a_row;
#   for ($i=0;$i<$num;$i++)
#   {
#    print $a_row[$i]." ";
#   }
#   print "<BR>\n";
  }
  $oradb->SQL_CloseQuery($cid);

  if ($found > 0)
  {
   if ($password eq $userpass)
   {
    set_cookie("geometry_username",$username);
    set_cookie("geometry_password",$password);
    &HTMLContentType;
    $title="Test Successfully Logged into Geometry Brain";
#    display_HTML_header($title);
    print '<DOCTYPE HTML PUBLIC "-//W3C/DTD HTML 4.01 Transitional//EN">';
    print "\n<HTML>\n";
    print "<HEAD>\n"; 
    print "<TITLE>$title</TITLE>\n";
    print "<META CONTENT=\"0;URL=$teacher_menu\" HTTP-EQUIV=\"Refresh\">\n";
#    print "<META CONTENT=\"1;URL=$teacher_menu\" HTTP-EQUIV=\"Refresh\">\n";
    print "</HEAD>\n";
    print "<BODY>\n";

    print "<A HREF=\"$teacher_menu\">Click here for menu</A><BR>\n";
#    print "Note: This should be an HTTP EQUIV to bring up a frameset<BR>\n";
#    display_HTML_footer();
    print "</BODY>\n";
    print "</HTML>\n";
#    print "<b>Successfully logged in as a teacher.</b><BR>\n";
#    teacher_menu();
# Go Teacher Menu
   }
   else
   {
    unset_cookie("geometry_username");
    unset_cookie("geometry_password");
    &HTMLContentType;
    $title="Login Failed";
    display_HTML_header($title);
    print "<b>Invalid Login.</b><BR>\n";
    $url=&HTMLScriptURL;
    print "<A HREF=\"$url\">Click here to login again.</A><BR>\n";
#    print "Note: Bad Teacher Password<BR>\n";
    display_HTML_footer();
    exit;
   }
  }
  else
  {
   unset_cookie("geometry_username");
   unset_cookie("geometry_password");
   &HTMLContentType;
   $title="Login Failed";
   display_HTML_header($title);
   print "<b>Invalid Login.</b><BR>\n";
   $url=&HTMLScriptURL;
   print "<A HREF=\"$url\">Click here to login again.</A><BR>\n";
#   print "Note: Bad Username<BR>\n";
   display_HTML_footer();
   exit;
  }
 }
}
