#!/umr/bin/perl
######################################################################
#
# Programmer: Mike Krasche
# Filename modify_test.pl
# Last Update: 05/08/2001
# Description: This scripts first presetns the user with a choice of
#    modifying each of the types of tests.  once the type is chosen
#    the user presses the submit button. (DI-1) The database is opened
#    and searches for the test with their user id as the owner and for 
#    the type they chose.  This will bring the user to a new screen that
#    displays the numbers of the current questions in the test.  These
#    fields can be edited to add, remove, or change questions.  This page
#    can then follow 2 different execution paths.  1. The user can hit
#    the submit button to change these questions.  This will open (DI-2)
#    and the database will look for each of the questions in the question
#    pool to make sure they are valid for the test (the subject is the
#    same as the test chosen).  If all questions are valid then an update
#    query is performed.  2. This execution path occurs when the user
#    hits the submit button to search for more questions.  They can either
#    enter a specific teacher's user id to find only their questions or
#    leave the field blank and serach all the questions for that subject.
#    When this submit button is pressed (DI-3) the database will be
#    opened and it will return all of the questions for the specified
#    user for the subject of the test the teacher is looking at.  Each
#    question found, it's choices for answers and the correct answer
#    will be output to the screen.  The user should hit the back button
#    at the bottom of the screen to return to the screen displaying the
#    current question.
#
# Inputs: The numbers for the selected questions in the test, the
#    user id for the teacher's questions you wish to find
# Outputs: The numbers of the current questions in the test, and if
#    the questions are searched then each question, it's answers and
#    correct answer will be output.
# Database Interactions: Labeled by (DI-?) in the description.
#
######################################################################


#http://wwwcgi.umr.edu/cgi-bin/cgiwrap/traxdev/modify_test.pl
use lib "/afs/umr.edu/software/umrperl/libs";
use UMR::OracleObject;
use UMR::HTMLUtil;

require "geometry_funcs.pl";

#$tnsname="ora_cs_test";
$title="Modifying a Test";

&HTMLGetRequest;
#&HTMLContentType;

$mode=$rqpairs{"mode"};

unless ($mode)
{
 get_cookies();   
 $username=$cookies{"geometry_username"};
 $password=$cookies{"geometry_password"};

 get_oracle_auth();

 $oradb = new UMR::OracleObject;

 unless ($oradb->SQL_OpenDatabase ($tnsname, %orainfo))
 {
  &HTMLContentType;
  display_HTML_header($title);
  $oradb->SQL_Error ("Can't open database");
  display_HTML_footer();
  exit;
 }
 
 if (is_teacher($username,$password) ne 1)
 {
  &HTMLContentType;
  display_HTML_header($title);
  print "Invalid login.<BR>\n";
  display_HTML_footer();
  exit;
 }

 &HTMLContentType;
 display_HTML_header($title);

  &HTMLStartForm(&HTMLScriptURL);
#  &HTMLTitle($title);

  print "\n";

 #Give the choices for which test you wish to modify/view.  
  print "Modify Test\n";
  print "<BR>\n";
  print "<BR>\n";
  print "<B>Select Session\n</B>";
  print "<BR>\n";
  &HTMLRadioButton("mode","Area",1,"  View The Area and Volume Test");
  print "<BR>\n";
  &HTMLRadioButton("mode","Polygon",0,"  View The Polygons and Their Measurements Test");
  print "<BR>\n";
  &HTMLRadioButton("mode","Trig",0,"  View the Trig Functions Test");
  print "<BR><BR>\n";
  &HTMLSubmit("Execute");

  print "\n"; 
  &HTMLEndForm;
  print "\n";
  display_HTML_footer();

}

if( $mode eq "Area" )
{
 get_cookies();   
 $username=$cookies{"geometry_username"};
 $password=$cookies{"geometry_password"};

 get_oracle_auth();

 $oradb = new UMR::OracleObject;

 unless ($oradb->SQL_OpenDatabase ($tnsname, %orainfo))
 {
  &HTMLContentType;
  display_HTML_header($title);
  $oradb->SQL_Error ("Can't open database");
  display_HTML_footer();
  exit;
 }
 
 if (is_teacher($username,$password) ne 1)
 {
  &HTMLContentType;
  display_HTML_header($title);
  print "Invalid login.<BR>\n";
  display_HTML_footer();
  exit;
 }

 &HTMLContentType;
  $title = "Area Test Questions";
 display_HTML_header($title);

#  &HTMLTitle($title);
  &HTMLStartForm(&HTMLScriptURL);
  &HTMLHidden("mode","UpdateTest");
  &HTMLHidden("subject","AREA AND VOLUME");

  $teachid = $username;
  &HTMLHidden("teacher",$teachid);

  print "\n";
  print "<B>Questions that are currently in the test\n </B>";
  print "<BR>\n"; 
  $subvalue = "AREA AND VOLUME";


  
 #open the database to run the query
#  get_oracle_auth();
#  $oradb = new UMR::OracleObject;
#  $oradb->SQL_OpenDatabase($tnsname, %orainfo) ||
#     $oradb->SQL_Error ("Can't open database");
       
 #Run the query to find the questions in the Areas test
  $subvalue = $oradb->SQL_QuoteString($subvalue);
  $teachid = $oradb->SQL_QuoteString($teachid);
  $qry = "SELECT Q1,Q2,Q3,Q4,Q5 FROM Test WHERE Subject=$subvalue and T_User_Id=$teachid"; 
  $cid = $oradb->SQL_OpenQuery($qry) or $oradb->SQL_Error && die "query failed";
 
 #if query is successful then find  the values for each of the questions
  if( @a_row = $oradb->SQL_FetchRow($cid) )
  {
     $q1 = $a_row[0];
     $q2 = $a_row[1];
     $q3 = $a_row[2];
     $q4 = $a_row[3];
     $q5 = $a_row[4];
  }

 #Put in a var name....$dvalue.....for the default value.  
 #Print out input boxes with the current questions in the test.  
  print "<BR>\n";
  print "Q1  ";
  &HTMLInputText("quest1",5,$q1);
  print "<BR>\n";

  print "Q2  ";
  &HTMLInputText("quest2",5,$q2);
  print "<BR>\n";

  print "Q3  ";
  &HTMLInputText("quest3",5,$q3);
  print "<BR>\n";

  print "Q4  ";
  &HTMLInputText("quest4",5,$q4);
  print "<BR>\n";

  print "Q5  ";
  &HTMLInputText("quest5",5,$q5);
  print "<BR><BR>\n";
  
  #When the form is submitted then the questions need to be processed
  &HTMLSubmit("Submit Question Changes");
  print "<BR><BR>\n";
  print "<HR>\n";
  &HTMLEndForm;
  print "\n";

  ######################################################################### 
  # Start a new form in order to have a submit button for question lookup #
  #########################################################################
  &HTMLStartForm(&HTMLScriptURL);
  &HTMLHidden("mode","Search"); 
  &HTMLHidden("subject","AREA AND VOLUME"); 

 #Get the user id the teacher wants to look for questions in
  print "<B>Enter the ID of the teacher you wish to find questions from</B>";
  print "<BR>\n";
  print "<B>or leave blank and search all questions for Area and Volume section</B>\n";
  print "<BR><BR>\n";
  print "Teacher User Id  ";
  &HTMLInputText("qpteachid",25,"");
  &HTMLSubmit("Search Question Pool");
  &HTMLEndForm;
  print "<BR>\n";

  display_HTML_footer();
}

if( $mode eq "Polygon" )
{
  $title = "<B>Polygons and Their Measurements Test</B>";
 get_cookies();   
 $username=$cookies{"geometry_username"};
 $password=$cookies{"geometry_password"};

 get_oracle_auth();

 $oradb = new UMR::OracleObject;

 unless ($oradb->SQL_OpenDatabase ($tnsname, %orainfo))
 {
  &HTMLContentType;
  display_HTML_header($title);
  $oradb->SQL_Error ("Can't open database");
  display_HTML_footer();
  exit;
 }
 
 if (is_teacher($username,$password) ne 1)
 {
  &HTMLContentType;
  display_HTML_header($title);
  print "Invalid login.<BR>\n";
  display_HTML_footer();
  exit;
 }

 &HTMLContentType;
 display_HTML_header($title);
#  &HTMLTitle($title);
  &HTMLStartForm(&HTMLScriptURL);
  &HTMLHidden("mode","UpdateTest");
  &HTMLHidden("subject","POLYGONS AND THEIR MEASUREMENTS");

####### HARDCODED TEACHER VALUE FOR CODE TO WORK ##########
  $teachid = $username;
  &HTMLHidden("teacher",$teachid);

  print "\n";
  print "<B>Questions that are currently in the test\n </B>";
  print "<BR>\n"; 
  $subvalue = "POLYGONS AND THEIR MEASUREMENTS";

 #A hardcoded teacher ID to test to see that the query works
#  $teachid = "1234";
  
 #open the database to run the query
#  get_oracle_auth();
#  $oradb = new UMR::OracleObject;
#  $oradb->SQL_OpenDatabase($tnsname, %orainfo) ||
#     $oradb->SQL_Error ("Can't open database");
       
 #Run the query to find the questions in the Areas test
  $subvalue = $oradb->SQL_QuoteString($subvalue);
  $teachid = $oradb->SQL_QuoteString($teachid);
  $qry = "SELECT Q1,Q2,Q3,Q4,Q5 FROM Test WHERE Subject=$subvalue and T_User_Id=$teachid"; 
  $cid = $oradb->SQL_OpenQuery($qry) or $oradb->SQL_Error && die "query failed";
 
 #if query is successful then find  the values for each of the questions
  if( @a_row = $oradb->SQL_FetchRow($cid) )
  {
     $q1 = $a_row[0];
     $q2 = $a_row[1];
     $q3 = $a_row[2];
     $q4 = $a_row[3];
     $q5 = $a_row[4];
  }

 #Put in a var name....$dvalue.....for the default value.  
 #Print out input boxes with the current questions in the test.  
  print "<BR>\n";
  print "Q1  ";
  &HTMLInputText("quest1",5,$q1);
  print "<BR>\n";

  print "Q2  ";
  &HTMLInputText("quest2",5,$q2);
  print "<BR>\n";

  print "Q3  ";
  &HTMLInputText("quest3",5,$q3);
  print "<BR>\n";

  print "Q4  ";
  &HTMLInputText("quest4",5,$q4);
  print "<BR>\n";

  print "Q5  ";
  &HTMLInputText("quest5",5,$q5);
  print "<BR><BR>\n";
  
  #When the form is submitted then the questions need to be processed
  &HTMLSubmit("Submit Question Changes");
  print "<BR><BR>\n";
  print "<HR>\n";
  &HTMLEndForm;
  print "\n";

  ######################################################################### 
  # Start a new form in order to have a submit button for question lookup #
  #########################################################################
  &HTMLStartForm(&HTMLScriptURL);
  &HTMLHidden("mode","Search"); 
  &HTMLHidden("subject","POLYGONS AND THEIR MEASUREMENTS"); 

 #Get the user id the teacher wants to look for questions in
  print "<B>Enter the ID of the teacher you wish to find questions from</B>";
  print "<BR>\n";
  print "<B>or leave blank and search all questions for Area and Volume section</B>\n";
  print "<BR><BR>\n";
  print "Teacher User Id  ";
  &HTMLInputText("qpteachid",25,"");
  &HTMLSubmit("Search Question Pool");
  &HTMLEndForm;
  print "<BR>\n";

  display_HTML_footer();
}


if( $mode eq "Trig" )
{
  $title = "Trig Functions";
 get_cookies();   
 $username=$cookies{"geometry_username"};
 $password=$cookies{"geometry_password"};

 get_oracle_auth();

 $oradb = new UMR::OracleObject;

 unless ($oradb->SQL_OpenDatabase ($tnsname, %orainfo))
 {
  &HTMLContentType;
  display_HTML_header($title);
  $oradb->SQL_Error ("Can't open database");
  display_HTML_footer();
  exit;
 }
 
 if (is_teacher($username,$password) ne 1)
 {
  &HTMLContentType;
  display_HTML_header($title);
  print "Invalid login.<BR>\n";
  display_HTML_footer();
  exit;
 }

 &HTMLContentType;
 display_HTML_header($title);
#  &HTMLTitle($title);
  &HTMLStartForm(&HTMLScriptURL);
  &HTMLHidden("mode","UpdateTest");
  &HTMLHidden("subject","TRIG FUNCTIONS");

####### HARDCODED TEACHER VALUE FOR CODE TO WORK ##########
  $teachid = $username;
  &HTMLHidden("teacher",$teachid);

  print "\n";
  print "<B>Questions that are currently in the test\n </B>";
  print "<BR>\n"; 
  $subvalue = "TRIG FUNCTIONS";

 #A hardcoded teacher ID to test to see that the query works
#  $teachid = "1234";
  
 #open the database to run the query
#  get_oracle_auth();
#  $oradb = new UMR::OracleObject;
#  $oradb->SQL_OpenDatabase($tnsname, %orainfo) ||
#     $oradb->SQL_Error ("Can't open database");
       
 #Run the query to find the questions in the Areas test
  $subvalue = $oradb->SQL_QuoteString($subvalue);
  $teachid = $oradb->SQL_QuoteString($teachid);
  $qry = "SELECT Q1,Q2,Q3,Q4,Q5 FROM Test WHERE Subject=$subvalue and T_User_Id=$teachid"; 
  $cid = $oradb->SQL_OpenQuery($qry) or $oradb->SQL_Error && die "query failed";
 
 #if query is successful then find  the values for each of the questions
  if( @a_row = $oradb->SQL_FetchRow($cid) )
  {
     $q1 = $a_row[0];
     $q2 = $a_row[1];
     $q3 = $a_row[2];
     $q4 = $a_row[3];
     $q5 = $a_row[4];
  }

 #Put in a var name....$dvalue.....for the default value.  
 #Print out input boxes with the current questions in the test.  
  print "<BR>\n";
  print "Q1  ";
  &HTMLInputText("quest1",5,$q1);
  print "<BR>\n";

  print "Q2  ";
  &HTMLInputText("quest2",5,$q2);
  print "<BR>\n";

  print "Q3  ";
  &HTMLInputText("quest3",5,$q3);
  print "<BR>\n";

  print "Q4  ";
  &HTMLInputText("quest4",5,$q4);
  print "<BR>\n";

  print "Q5  ";
  &HTMLInputText("quest5",5,$q5);
  print "<BR><BR>\n";
  
  #When the form is submitted then the questions need to be processed
  &HTMLSubmit("Submit Question Changes");
  print "<BR><BR>\n";
  print "<HR>\n";
  &HTMLEndForm;
  print "\n";

  ######################################################################### 
  # Start a new form in order to have a submit button for question lookup #
  #########################################################################
  &HTMLStartForm(&HTMLScriptURL);
  &HTMLHidden("mode","Search"); 
  &HTMLHidden("subject","TRIG FUNCTIONS"); 

 #Get the user id the teacher wants to look for questions in
  print "<B>Enter the ID of the teacher you wish to find questions from</B>";
  print "<BR>\n";
  print "<B>or leave blank and search all questions for Area and Volume section</B>\n";
  print "<BR><BR>\n";
  print "Teacher User Id  ";
  &HTMLInputText("qpteachid",25,"");
  &HTMLSubmit("Search Question Pool");
  &HTMLEndForm;
  print "<BR>\n";

  display_HTML_footer();
}

#This section will execute if the user has chosen to change the questions
#that are currently in the test
if( $mode eq "UpdateTest" )
{
 #Print the title for the page
  $title = "Test Updated";
 get_cookies();   
 $username=$cookies{"geometry_username"};
 $password=$cookies{"geometry_password"};

 get_oracle_auth();

 $oradb = new UMR::OracleObject;

 unless ($oradb->SQL_OpenDatabase ($tnsname, %orainfo))
 {
  &HTMLContentType;
  display_HTML_header($title);
  $oradb->SQL_Error ("Can't open database");
  display_HTML_footer();
  exit;
 }
 
 if (is_teacher($username,$password) ne 1)
 {
  &HTMLContentType;
  display_HTML_header($title);
  print "Invalid login.<BR>\n";
  display_HTML_footer();
  exit;
 }

 &HTMLContentType;
 display_HTML_header($title);
  &HTMLStartForm(&HTMLScriptURL);
#  &HTMLTitle($title);
  $sqlerror = "An Error Occurred!  You may have entered an invalid question number or the database is down.  Please try the test update again.\n";
  
 #set the variables from the input boxes on the prev screen for each of
 #the test questions
  $q1 = $rqpairs{"quest1"};
  chomp($q1);

  $q2 = $rqpairs{"quest2"};
  chomp($q2);

  $q3 = $rqpairs{"quest3"};
  chomp($q3);

  $q4 = $rqpairs{"quest4"};
  chomp($q4);
  
  $q5 = $rqpairs{"quest5"};
  chomp($q5);
  
  $sub = $rqpairs{"subject"};
  chomp($sub);

  $sub2 = $rqpairs{"subject"};
  chomp($sub2);
     
#  $teachid = $rqpairs{"teacher"};
#  chomp($teachid);
  $teachid = $username;
 
 #open the database to run the query
#  get_oracle_auth();
#  $oradb = new UMR::OracleObject;
#  $oradb->SQL_OpenDatabase($tnsname, %orainfo) ||
#     $oradb->SQL_Error ("Can't open database");

  $q1 = $oradb->SQL_QuoteString($q1);
  $q2 = $oradb->SQL_QuoteString($q2);
  $q3 = $oradb->SQL_QuoteString($q3);
  $q4 = $oradb->SQL_QuoteString($q4);
  $q5 = $oradb->SQL_QuoteString($q5);
  $sub = $oradb->SQL_QuoteString($sub);
  $teachid = $oradb->SQL_QuoteString($teachid);
 
 #First test to see if the test contains valid questions
  $qry = "SELECT Q_No, Subject FROM Question_Pool WHERE Q_No=$q1 or Q_No=$q2 or Q_No=$q3 or Q_No=$q4 or Q_No=$q5";
#  print "Print query: \"$qry\" \n";
#  print "<BR>\n";
  $cid = $oradb->SQL_OpenQuery($qry) or $oradb->SQL_Error && die "query failed";

#  print "Sent query \"$qry\" to database\n";
#  print "<BR>\n";
  
#  print "The value of subject is \"$subject\"\n";
#  print "<BR>\n";
  
 #View the results of the query to see if the test is valid  
  $count = 0;
  $badinput = 0;
  while( @a_row = $oradb->SQL_FetchRow($cid) )
  {
     if ( $a_row[1] eq $sub2 )
     {
        $count++;
     }
     else
     {
        print "Error: Question number ";
	print $a_row[0];
	print " is invalid for this test.\n";
 	print "<BR>\n";
	$badinput = 1;
     }
  }

 #If all 5 questions are valid then update the test
  if( $badinput eq 0 )
  {   
   #Set the query so that it updates all of the questions in the test
    $qry = "UPDATE Test SET Q1=$q1, Q2=$q2, Q3=$q3, Q4=$q4, Q5=$q5,
    No_Questions= $count WHERE Subject=$sub and T_User_Id=$teachid";

   #Send the query to the database
#    print "Print query: \"$qry\" \n";
#    print "<BR>\n";
    $oradb->SQL_ExecQuery($qry) or $sqlerror && die "query failed";
#    print "Sent query \"$qry\" to database\n";
    print "<BR>The test was successfully changed\n";
  }
  else
  {
     print "<BR>The test was not successfully changed\n";
  }
  &HTMLEndForm;

  display_HTML_footer();
}

if( $mode eq "Search" )
{
 #Print the title for the page
  $title = "Question Pool";
 get_cookies();   
 $username=$cookies{"geometry_username"};
 $password=$cookies{"geometry_password"};

 get_oracle_auth();

 $oradb = new UMR::OracleObject;

 unless ($oradb->SQL_OpenDatabase ($tnsname, %orainfo))
 {
  &HTMLContentType;
  display_HTML_header($title);
  $oradb->SQL_Error ("Can't open database");
  display_HTML_footer();
  exit;
 }
 
 if (is_teacher($username,$password) ne 1)
 {
  &HTMLContentType;
  display_HTML_header($title);
  print "Invalid login.<BR>\n";
  display_HTML_footer();
  exit;
 }

 &HTMLContentType;
 display_HTML_header($title);

  &HTMLStartForm(&HTMLScriptURL);
#  &HTMLTitle($title); 

 #Get the value of the subject we are working with
  $sub = $rqpairs{"subject"};
  chomp($sub);

 #This tells the script which test selection screen to go back to
  if( $sub eq "AREA AND VOLUME" )
  {
     &HTMLHidden("mode","Area");
  }
  if( $sub eq "POLYGONS AND THEIR MEASUREMENTS" )
  {
     &HTMLHidden("mode","Polygon");
  }
  if( $sub eq "TRIG FUNCTIONS" )
  {
     &HTMLHidden("mode","Trig");
  }
  print "\n"; 
  print "<B>Question Pool</B>";
  print "<BR><BR>\n";

 
 #open the database to run the query
#  get_oracle_auth();
#  $oradb = new UMR::OracleObject;
#  $oradb->SQL_OpenDatabase($tnsname, %orainfo) ||
#     $oradb->SQL_Error ("Can't open database");

 #Test to see if a teacher id was entered
  $searchtid = $rqpairs{"qpteachid"};
  chomp($searchtid);
  $quoted_searchtid = $oradb->SQL_QuoteString($searchtid);

 #Get the value of the subject we are working with
  $sub = $rqpairs{"subject"};
  chomp($sub);
  $sub = $oradb->SQL_QuoteString($sub);

 #If the textbox is blank then return all questions that are in that subject, otherwise
 #return the questions that are owned by the user $searchtid.
  if($searchtid eq "")
  {
   #Run the query to find all of the questions that meet the criteria       
    $qry = "select Q_No, Question, Answer_1, Answer_2, Answer_3, Answer_4, ".
      "Correct_Number from Question_Pool where Subject=$sub"; 
  }
  else
  {
   #Run a query for the teacher that was specified
    $qry = "select Q_No, Question, Answer_1, Answer_2, Answer_3, Answer_4, ".
      "Correct_Number from Question_Pool where Subject=$sub and ".
      "Owner=$quoted_searchtid";
  }
  $cid = $oradb->SQL_OpenQuery($qry) or $oradb->SQL_Error && die "query failed";
#  print "Sent query \"$qry\" to database\n";  
  
 #If the query is successful then print the results of the query in a table to
 #display the questions that were found.
  $count = 0;
  while( @a_row = $oradb->SQL_FetchRow($cid) )
  {
        $count = 1;
	print "<BR>\n";
	print $a_row[0];
	print ".   ";
        print $a_row[1];	
        print "<BR>\n";
	print "A. ";
	print $a_row[2];
	print "<BR>\n";
	print "B. ";
	print $a_row[3];
	print "<BR>\n";
	print "C. ";
	print $a_row[4];
	print "<BR>\n";
	print "D. ";
	print $a_row[5];
	print "<BR>\n";
        print "Correct Answer: ";
	print $a_row[6]; 
        print "\n";
	print "<BR><BR>\n";
  }
  if ($count eq 0)
  {
     print "<BR><BR>\n";
     print "<B>No Questions Found For This Teacher</B>";
     print "<BR><BR>\n";
  }   
  print "<BR>Click to return to previous page.<BR>\n";
  &HTMLSubmit("<- Back");
   
  &HTMLEndForm;
  display_HTML_footer();
}
