#!/umr/bin/perl

# Test script for Geometry Brain project
# Written by Ryan Lantzer
# Last updated 4/19/01

use lib "/afs/umr.edu/software/umrperl/libs";

use UMR::OracleObject;
use UMR::HTMLUtil;

require "geometry_funcs.pl";


$title="Class Roster";

# Initialize %rqpairs with submitted variables
&HTMLGetRequest;

# Check variable "mode" to decide what the script should do
$mode=$rqpairs{"mode"};

# Base case when no mode has been set
# Prints out a list of students in the teacher's class
# Provides class roster options
unless ($mode)
{
 get_cookies();
 $username=$cookies{"geometry_username"};
 $password=$cookies{"geometry_password"};

 get_oracle_auth();
  
 $oradb = new UMR::OracleObject;

 unless ($oradb->SQL_OpenDatabase ($tnsname, %orainfo))
 {
  &HTMLContentType;
  display_HTML_header($title);
  $oradb->SQL_Error ("Can't open database");
  display_HTML_footer();
  exit;
 }

 if (is_teacher($username,$password) ne 1)
 {
  &HTMLContentType;
  display_HTML_header($title);
  print "Invalid login.<BR>\n";
  display_HTML_footer();
  exit;
 }


#select user_id,fname,lname from student,teaches where 
#s_user_id=user_id    
#and t_user_id='1234' order by lname,fname;

 &HTMLContentType;
 display_HTML_header($title);

 $quoted_teacheruserid = $oradb->SQL_QuoteString($username);

 $qry="select lname,fname,user_id from student,teaches where ".
  "s_user_id=user_id and t_user_id=$quoted_teacheruserid order by lname,fname";

 $cid=$oradb->SQL_OpenQuery($qry) or $oradb->SQL_Error && die "query failed";
  
# print "Sent query \"$qry\" to database<BR>\n";
# print "Query Results:<BR>\n";
# print "<TABLE BORDER=0>\n";
# print "<TR><TD>Last Name</TD><TD>First Name</TD><TD>User ID</TD>";
# print "</TR>\n";
# print "<TR></TR>\n";

#print "<TR><td>\n";

 print "List of Students<BR>\n";
 print "<BR>\n";

 $num_students=0;
 while ( @a_row = $oradb->SQL_FetchRow($cid) )
 {
  $studentlist[$num_students]=$a_row[0].", ".$a_row[1]." (".$a_row[2].")";
  $studentids[$num_students]=$a_row[2];
  $num_students++;
 }
 $oradb->SQL_CloseQuery($cid);

 if ($num_students>0)
 {
  &HTMLStartForm(&HTMLScriptURL);
  &HTMLHidden("mode","view_details");
  print "\n";
  print "<SELECT NAME=\"student\" SIZE=$num_students>\n";

  for ($i=0;$i<$num_students;$i++)
  {
   print "<OPTION VALUE=\"".$studentids[$i]."\"";
   if ($i == 0)
   {
    print " SELECTED";
   }
   print ">\n";
   print $studentlist[$i]."\n";
  }
  print "</SELECT><BR>\n";
  print "<BR>\n";

  &HTMLSubmit("Display Student Details");
  &HTMLEndForm;
 }
 else
 {
  print "You have no students.<BR>\n";
 }
#print "</td></tr>\n";
# print "</TABLE>\n";

# print "<BR><BR>\n";
# print "<A HREF=\"addstudent.pl\">Add Students</A><BR>\n";
 &HTMLStartForm("addstudent.pl");
 print "\n";
# &HTMLHidden("mode","view_details");
# print "\n";
 &HTMLSubmit("Add Students");
 print "\n";
 &HTMLEndForm;
 print "\n";

# print "Delete all students<BR>\n";
 &HTMLStartForm(&HTMLScriptURL);
 print "\n";
 &HTMLHidden("mode","delete_all_students");
 print "\n";
 &HTMLSubmit("Delete All Students");
 print "\n";
 &HTMLEndForm;
 print "\n";
# print "Delete a student<BR>\n";


 display_HTML_footer();
}

if ($mode eq "view_details")
{
 $title = "Student Information Page";
 get_cookies();
 $username=$cookies{"geometry_username"};
 $password=$cookies{"geometry_password"};   

 get_oracle_auth();
  
 $oradb = new UMR::OracleObject;
 
 unless ($oradb->SQL_OpenDatabase ($tnsname, %orainfo))
 {
  &HTMLContentType;
  display_HTML_header($title);
  $oradb->SQL_Error ("Can't open database");
  display_HTML_footer();
  exit;
 }
  
 if (is_teacher($username,$password) ne 1)
 {
  &HTMLContentType;
  display_HTML_header($title);
  print "Invalid login.<BR>\n";
  display_HTML_footer();
  exit;
 }


# #$user_id = '1234-028';
# $user_id = '1234-004';
 $user_id=$rqpairs{"student"};

## Initialize %rqpairs with submitted variables
#&HTMLGetRequest;
 &HTMLContentType;
 display_HTML_header($title);

## Check variable "mode" to decide what the script should do
#$mode = $rqpairs{"mode"};

# Begin Oracle authenication subroutine
# get_oracle_auth();

# Create a new Oracle connection object
# $oradb = new UMR::OracleObject;

# Connect to database using USER_ID and PASSWORD from get_oracle_auth()
# $oradb->SQL_OpenDatabase($tnsname, %orainfo)||
#    $oradb->SQL_Error("Can't open database!!!");

 $s_user_id = $oradb->SQL_QuoteString($user_id);

#unless ($mode)
#{

# &HTMLTitle($title);

# Create a query statement
# Eventually, the querry will pass on the student id from the web team

 $query_student = "select user_id, fname, lname from student s where ".
  "s.user_id = $s_user_id"; 
   
 # Student exam query
 $query_exam_record = "select subject, test_status, date_practice, ".
  "date_test from exam_record e where e.s_user_id = $s_user_id";

 # Submit a query and return a connection id
 $cid = $oradb->SQL_OpenQuery($query_student)
   or $oradb->SQL_Error("Query failed");

 # Student info report
 # Print header for report
 print "<TABLE BORDER = 0> \n";
 print "<TR><TD>User ID</TD><TD>First Name</TD><TD>Last Name</TD></TR> \n";

 # Return a_row from query
 @a_row = $oradb->SQL_FetchRow($cid);

 # Print out student info
 print "<TR>\n";
 $num=@a_row;
 for ($i=0;$i<$num;$i++)
 {
    print "<TD>";
    print $a_row[$i];
    print "</TD>\n";
 }
 print "</TR>\n";
 #print "<BR>\n";
 print "</TABLE> \n";

  # Close query connection
 $oradb->SQL_CloseQuery($cid);

 print "<BR>\n";

 # Submit a query and return a connection id
 $cid_exam = $oradb->SQL_OpenQuery($query_exam_record) or 
    $oradb->SQL_Error("Query failed");

 # Exam record report
 # Print header for exam report
 print "<TABLE BORDER = 0>\n";
 print "<TR><TD></TD>\n";
 print "<TD>Subject</TD><TD>Test Status</TD><TD>Date Practice</TD>\n";
 print "<TD>Date Test<TD></TR>\n";

 # While loop to print out all result from query
 $j=0;


 #######################################
 &HTMLStartForm(&HTMLScriptURL);
 #######################################
 print "\n";
 &HTMLHidden("mode","reset_lesson");
 &HTMLHidden("student", $user_id);
 print "\n";

 while(@a_row = $oradb->SQL_FetchRow($cid_exam))
 {
    $subject[$j] = $a_row[0];
   
    # Print out student exam info
    print "<TR><TD>";
   
    # Default button selection
    $k = 0;
    if ($j eq 0)
    {
       $k = 1;
    }
   
    &HTMLRadioButton("subject", $subject[$j], $k);
   
    # Increment subject counter
    $j++;
   
    print "</TD>\n";
    $num=@a_row;
   
    for ($i=0;$i<$num;$i++)
    {
       print "<TD>";
       print $a_row[$i];
       print "</TD>\n";
    }
    print "</TR>\n";
#   print "<BR>\n";
 }
 print "</TABLE> \n";

 # Close query connection
 $oradb->SQL_CloseQuery($cid_exam);

 print "<BR>\n";

 # Reset and display lesson
 &HTMLSubmit("Reset Lesson");
 print "\n";

 &HTMLEndForm;
 print "\n";

 &HTMLStartForm(&HTMLScriptURL);
 print "\n";

 # Reset and display new student password
 &HTMLHidden("mode", "reset_password");
 print "\n";
 &HTMLHidden("student", $user_id);
 print "\n";
 &HTMLSubmit("Reset Password");
 print "\n";

 ############################
 &HTMLEndForm;
 ###########################
 print "\n";

# print "Delete student<BR>\n";
 &HTMLStartForm(&HTMLScriptURL);
 print "\n";
 &HTMLHidden("mode", "delete_student");
 print "\n";
 &HTMLHidden("student", $user_id);
 print "\n";
 &HTMLSubmit("Delete Student");
 print "\n";
 &HTMLEndForm;

 display_HTML_footer();
}

if ($mode eq "reset_password")
{
 $title = "Reset Student Password";
 get_cookies();
 $username=$cookies{"geometry_username"};
 $password=$cookies{"geometry_password"};   

 get_oracle_auth();
  
 $oradb = new UMR::OracleObject;
 
 unless ($oradb->SQL_OpenDatabase ($tnsname, %orainfo))
 {
  &HTMLContentType;
  display_HTML_header($title);
  $oradb->SQL_Error ("Can't open database");
  display_HTML_footer();
  exit;
 }
  
 if (is_teacher($username,$password) ne 1)
 {
  &HTMLContentType;
  display_HTML_header($title);
  print "Invalid login.<BR>\n";
  display_HTML_footer();
  exit;
 }


 # Got from the Perl Monk Forum by Russ
 #
 # Creates passwords from a customizable list of characters
 # (To make it easier on users, don't use zero or capital 'O', for example)
 #
 # *Not* a completely security-conscious implementation, especially when 
 # generating multiple passwords at once...
 #
 # Change @Chars to suit your preference
 # Change the inner for loop to determine password length
 # 
 # Usage: $0 [Number of passwords to generate]

 sub pass_gen
 { 
    my @chars_list = split '',         
       'abcdefghijkmnopqrstuvwxyzABCDEFGHJKMNPQRSTUVWXYZ23456789';
    for (1..($ARGV[0] ||= 1))
    {
       $password_gen;
       for (1..6)
       { 
          $password_gen .= $chars_list[rand @chars_list];
       }
    }
 }

 $user_id=$rqpairs{"student"};
 $s_user_id = $oradb->SQL_QuoteString($user_id);

 &HTMLContentType;
 display_HTML_header($title);

   pass_gen();
   # Create Oracle safe
   my $new_password_gen = $oradb->SQL_QuoteString($password_gen);
   
   # Reset student password query
   $query_reset_password = "update student set password = $new_password_gen ".
      "where user_id = $s_user_id";

   # Open query connection for print out of old password
   $cid_reset_password = $oradb->SQL_OpenQuery("select password from ".
      "student where user_id = $s_user_id")
      or $oradb->SQL_Error("Query failed");
   
   @a_row = $oradb->SQL_FetchRow($cid_reset_password);
   
   # Print out old password
   print "This is the old password:  ";
   print $a_row[0];
   print "<BR>";

   # Close querry connection
   $oradb->SQL_CloseQuery($cid_reset_password);

   # Open new query connection for query_reset_password
   $cid_reset_password = $oradb->SQL_OpenQuery($query_reset_password) or
      $oradb->SQL_Error("Query failed");
      
   # Close query connection
   $oradb->SQL_CloseQuery($cid_reset_password);
   
   # Open query connection for print out of new password
   $cid_reset_password = $oradb->SQL_OpenQuery("select password from student ".
      "where user_id = $s_user_id") or $oradb->SQL_Error("Query failed");
   
   @a_row = $oradb->SQL_FetchRow($cid_reset_password);
      
   # Print out new password
   print "This is the new password:  ";
   print $a_row[0];
   print "<BR>";

   # Close query connection
   $oradb->SQL_CloseQuery($cid_reset_password);

 display_HTML_footer();

}

if ($mode eq "reset_lesson")
{
 $title = "Reset Student Test";
 get_cookies();
 $username=$cookies{"geometry_username"};
 $password=$cookies{"geometry_password"};   

 get_oracle_auth();
  
 $oradb = new UMR::OracleObject;
 
 unless ($oradb->SQL_OpenDatabase ($tnsname, %orainfo))
 {
  &HTMLContentType;
  display_HTML_header($title);
  $oradb->SQL_Error ("Can't open database");
  display_HTML_footer();
  exit;
 }
  
 if (is_teacher($username,$password) ne 1)
 {
  &HTMLContentType;
  display_HTML_header($title);
  print "Invalid login.<BR>\n";
  display_HTML_footer();
  exit;
 }


 $user_id=$rqpairs{"student"};
 $s_user_id = $oradb->SQL_QuoteString($user_id);

 &HTMLContentType;
 display_HTML_header($title);

 $lesson=$rqpairs{"subject"};


   # Create Oracle safe
#   my $new_mode = $oradb->SQL_QuoteString($mode);
   my $new_mode = $oradb->SQL_QuoteString($lesson);
   
   # Reset lesson
#   $query_reset_lesson = "update exam_record set date_practice = NULL 
#      where s_user_id = $s_user_id and subject = $new_mode";
   $query_reset_lesson = "update exam_record set date_test = NULL, ".
      "test_status = 'Not Taken' where s_user_id = $s_user_id and ".
      "subject = $new_mode";
      
   # Open query connection
   $cid_reset_lesson = $oradb->SQL_OpenQuery($query_reset_lesson) or 
      $oradb->SQL_Error("Query failed");
      
   # Close query connection
   $oradb->SQL_CloseQuery($cid_reset_lesson);
      
   # Display updated lesson
   $cid_reset_lesson = $oradb->SQL_OpenQuery("select subject, test_status, 
      date_practice, date_test from exam_record e 
      where e.s_user_id = $s_user_id and e.subject = $new_mode") 
      or $oradb->SQL_Error("Query failed");

   # Exam record report
   # Print header for exam report
   print "<TABLE BORDER = 0>";
   print "<TR>";
   print "<TD>Subject</TD><TD>Test Status</TD><TD>Date Practice</TD>";
   print "<TD>Date Test<TD></TR>";

   @a_row = $oradb->SQL_FetchRow($cid_reset_lesson);

   $num=@a_row;
   print "<TR>";
   for ($i=0;$i<$num;$i++)
   {
      print "<TD>";
      print $a_row[$i];
      print "</TD>\n";
   }
   print "</TR>\n";
   
   print "</TABLE> \n";      

 display_HTML_footer();
}

if ($mode eq "delete_student")
{
 $title = "Delete Student";
 get_cookies();
 $username=$cookies{"geometry_username"};
 $password=$cookies{"geometry_password"};   

 get_oracle_auth();
  
 $oradb = new UMR::OracleObject;
 
 unless ($oradb->SQL_OpenDatabase ($tnsname, %orainfo))
 {
  &HTMLContentType;
  display_HTML_header($title);
  $oradb->SQL_Error ("Can't open database");
  display_HTML_footer();
  exit;
 }
  
 if (is_teacher($username,$password) ne 1)
 {
  &HTMLContentType;
  display_HTML_header($title);
  print "Invalid login.<BR>\n";
  display_HTML_footer();
  exit;
 }


 &HTMLContentType;
 display_HTML_header($title);

# $lesson=$rqpairs{"subject"};

 $Student_Id=$rqpairs{"student"};
# $s_user_id = $oradb->SQL_QuoteString($user_id);
 $Teacher_Id=$username;





 ########################################
 ## checking for deleting  a student process,
 ## first need to check whether the teacher and student
 ## exist in the database or not, then issuing deletion.
 #######################################    

 ######### check for whether the teacher is existed in the database or not ############

# $Teacher_Id = $oradb->SQL_QuoteString($Teacher_Id); #this function->no need for quote strings;
 
# $qry="select * from Teacher where User_id = $Teacher_Id";

# $cid=$oradb->SQL_OpenQuery($qry) or $oradb->SQL_Error && die "query failed";
 
# $found_teacher=0;
  
# while( @a_row = $oradb->SQL_FetchRow($cid) )
# {
#   $found_teacher=1;   
#  # $oradb->SQL_CloseQuery($cid);
# }  
 
 #### check for whether the student is existed in the database or not ####
 
 $quoted_Student_Id = $oradb->SQL_QuoteString($Student_Id);
 #this function->no need for quote strings;
 
 $qry="select * from STUDENT where User_id = $quoted_Student_Id";

 $cid=$oradb->SQL_OpenQuery($qry) or $oradb->SQL_Error && die "query failed";
  
 $found_student= 0;
 
 while( @a_row = $oradb->SQL_FetchRow($cid) )
 {
   $found_student=1;
  # $oradb->SQL_CloseQuery($cid);
 } 
 $oradb->SQL_CloseQuery($cid);
 
  #### end of checking the student and teacher in the database #######
 
# if( $found_teacher==1 and $found_student==1 )
 if( $found_student==1 )
 {
       ##### deletion a student process ###########                  
 
       $qry="delete from STUDENT where user_id = $quoted_Student_Id";
 
       $del_sucess= $oradb->SQL_ExecQuery ($qry);
     
        #### -> successfully deleted ####
       
       #$oradb->SQL_CloseQuery($cid);
#       &HTMLContentType;
#       &HTMLTitle($title);
       print "<b>Student deletion is Successful.</b><BR>\n";
#       student_menu();
#       exit;      
  }
 
# if ( $found_teacher == 0 and $found_student == 1 )
# {
#    &HTMLContentType;
#    &HTMLTitle($title);
#    print "<B>Invalid Teacher ID. Please go back and try again</B><BR>\n";
#    exit;
# }
 if ( $found_student == 0)
 {
#    &HTMLContentType;
#    &HTMLTitle($title);
    print "<B>Ivalid student ID.  Please go back and try again.</B><BR>\n";
#    exit;
 } 
# else
# {
#    &HTMLContentType;
#    &HTMLTitle($title);
#    print "<B>Invalid Student ID and Teacher ID.</B><BR>\n";
#    exit;
# } 
 
#}

 display_HTML_footer();
}

if ($mode eq "delete_all_students")
{
 $title = "Delete All Students";
 get_cookies();
 $username=$cookies{"geometry_username"};
 $password=$cookies{"geometry_password"};   

 get_oracle_auth();
  
 $oradb = new UMR::OracleObject;
 
 unless ($oradb->SQL_OpenDatabase ($tnsname, %orainfo))
 {
  &HTMLContentType;
  display_HTML_header($title);
  $oradb->SQL_Error ("Can't open database");
  display_HTML_footer();
  exit;
 }
  
 if (is_teacher($username,$password) ne 1)
 {
  &HTMLContentType;
  display_HTML_header($title);
  print "Invalid login.<BR>\n";
  display_HTML_footer();
  exit;
 }


 &HTMLContentType;
 display_HTML_header($title);

# $lesson=$rqpairs{"subject"};

 $Student_Id=$rqpairs{"student"};
# $s_user_id = $oradb->SQL_QuoteString($user_id);
 $Teacher_Id=$username;



    ###### checking for deleting all student process #####

  $quoted_Teacher_Id = $oradb->SQL_QuoteString($Teacher_Id);
 #this function->no need for quotes string;
 
  $qry="select * from Teacher where User_id = $quoted_Teacher_Id";

 $cid=$oradb->SQL_OpenQuery($qry) or $oradb->SQL_Error && die "query failed";
 
# $found_teacher=0;
 
 # check for whether the teacher is existed in the database or not
  
# while( @a_row = $oradb->SQL_FetchRow($cid) )
# {
#   $found_teacher=1;
#   $Id_number = @a_row[0];    
#   $oradb->SQL_CloseQuery($cid);
# }    
  
# if( $found_teacher==1 )
# { 
#       if ( $Teacher_Id eq $Id_number )
#       {
        #### delete all student process #########
    	$qry="delete from STUDENT where user_id like '$Teacher_Id-%'";
  
   	$del_all_sucess= $oradb->SQL_ExecQuery ($qry);
       
 #       &HTMLContentType;
 #       &HTMLTitle($title);
        print "<b>All Students deleted.</b><BR>\n";
#        student_menu();
#	exit;    
#       } 
#  } 
   
# else
# {     
#   &HTMLContentType;
#   &HTMLTitle($title);
#   print "<b>Invalid Teacher ID.  The ID is not found in the database. 
#Please check the ID again.</b><BR>\n";
#   exit;
# }
  

 display_HTML_footer();
}

