#!/umr/bin/perl

#This script has been written by K.N. Swamy, updated 04/28/01
#This script allows a teacher to enter questions into question pool
#and allows a student to take a test.  After a student takes a test,
#an email is sent to the teacher immediately if the student passes.

use lib "/afs/umr.edu/software/umrperl/libs";

use UMR::OracleObject;
use UMR::HTMLUtil;

require "geometry_funcs.pl";
#$title="Test Oracle Query";
#$tnsname="ora_cs_test";

#contains login and password information for the database
#This needs to be changed during deployment
#$orainfo{"user"}="traxdev";
#$orainfo{"passwd"}="buildtrx";

#get_oracle_auth();

#$oradb = new UMR::OracleObject;


                            
# This should match the mail program on your system.
my $mailprog = '/usr/sbin/sendmail';

&HTMLGetRequest;
#&HTMLContentType;
#display_HTML_header($title);
#&HTMLTitle($title);

#establishes what mode the page is in
$mode=$rqpairs{"mode"};

#-----------------------------------------------
# Show test questions. This script shows all
# the test questions for the test.  The user
# must have clicked "Take Test" button to
# have run this script.  Once the student finishes
# the test by clicking the "submit" button, the
# student will be shown a review of his questions
# that he answered wrong.  A record is made in the
# student record table whether the student passed
# or failed the test.  Also an e-mail is 
# sent to the teacher if the student passes.  
#-----------------------------------------------
unless ($mode)
{
 get_cookies();
 $username=$cookies{"geometry_username"};
 $password=$cookies{"geometry_password"};

 get_oracle_auth();
  
 $oradb = new UMR::OracleObject;

 unless ($oradb->SQL_OpenDatabase ($tnsname, %orainfo))
 {
  &HTMLContentType;
  display_HTML_header($title);
  $oradb->SQL_Error ("Can't open database");
  display_HTML_footer();
  exit;
 }

 $is_student=is_student($username,$password);
 if ($is_student ne 1)
 {
  $is_teacher=is_teacher($username,$password);
  if ($is_teacher ne 1)
  {
   &HTMLContentType;
   display_HTML_header($title);
   print "Invalid login.<BR>\n";
   display_HTML_footer();
   exit;
  }
 }

 $arg_subject=$ARGV[0];
 $subject=$arg_subject;
 $title="$subject Test";

 &HTMLContentType;
 display_HTML_header($title);


# $username=$rqpairs{"username"};
# chomp($username);
# $subject=$rqpairs{"choice"};
# chomp($subject);
# $teachname=$rqpairs{"teachername"};
 
#  $oradb->SQL_OpenDatabase ($tnsname, %orainfo) ||
#  $oradb->SQL_Error ("Can't open database");

 $quoted_username = $oradb->SQL_QuoteString($username);
 $subject = $oradb->SQL_QuoteString($subject);
# $teachname = $oradb->SQL_QuoteString($teachname);

 if ($is_teacher)
 {
  $teachname=$username;
 }
 else
 {
 	$qry = "SELECT T_User_Id from TEACHES Where S_User_Id = $quoted_username";

# 	print "About to send query \"$qry\" to database<BR>\n";

$cid=$oradb->SQL_OpenQuery($qry) or $oradb->SQL_Error && die "query failed";

# 	print "Sent query \"$qry\" to database<BR>\n";
 
 	while ( @a_row = $oradb->SQL_FetchRow($cid) )
 	{
          $teachname=$a_row[0];
# 	&HTMLHidden("teachername",$a_row[0]);
# 	print "\n";
 	}

 }
 $quoted_teachname = $oradb->SQL_QuoteString($teachname);

 $ok_to_take_test=1;
 if ($is_student)
 {
  $qry = "SELECT Test_Status From EXAM_RECORD Where (S_USER_ID = ".
         "$quoted_username) AND (Subject=$subject)";
#print "About to run $qry<BR>\n";
  $cid=$oradb->SQL_OpenQuery($qry) or $oradb->SQL_Error && die "query failed";
  @a_row = $oradb->SQL_FetchRow($cid);
  if ($a_row[0] ne "Not Taken")
  {
   $ok_to_take_test=0;
  }
  $oradb->SQL_CloseQuery($cid);
 }
 
# if ($a_row[0] eq "pass") 
#  if ($a_row[0] eq "Not Taken") 
  if ($ok_to_take_test == 1) 
  {

   if ($is_student)
   {
    $qry="UPDATE EXAM_RECORD set TEST_STATUS = 'Taken' ".
        "Where (S_USER_ID = $quoted_username) AND ".
        "(SUBJECT=$subject)";
#  print "About to send query \"$qry\" to database<BR>\n";
    $cid=$oradb->SQL_OpenQuery($qry) or $oradb->SQL_Error && die "query failed";
    $oradb->SQL_CloseQuery($cid);
   }
  

  $qry = "SELECT DISTINCT Q.Q_NO,QUESTION,ANSWER_1,ANSWER_2,ANSWER_3,ANSWER_4,".
 	"CORRECT_NUMBER,OWNER from TEST T, QUESTION_POOL Q ".
 	"Where ((T.SUBJECT = $subject) AND (T.T_USER_ID = $quoted_teachname) AND ".
 	"((Q.Q_NO=Q5) OR (Q.Q_NO=Q4) OR (Q.Q_NO=Q3) OR (Q.Q_NO=Q2) OR ". 
 	"(Q.Q_NO=Q1)))";
 	
#	print "About to send query \"$qry\" to database<BR>\n";

	$cid=$oradb->SQL_OpenQuery($qry) or $oradb->SQL_Error && die "query failed";

 	&HTMLStartForm(&HTMLScriptURL);
 	print "\n";
 	&HTMLHidden("mode","review_test");
 	$number = 1;
 	@choice = ("1");
   print "<OL>\n";
 
 
 	while ( @a_row = $oradb->SQL_FetchRow($cid) )
 	{
   	@choice = (@choice,"$number");
    print "<LI>";
#   	print $a_row[0]." ";
#   	print $a_row[1]." ";
   	print $a_row[1];
   	print "<BR>\n";
   	&HTMLRadioButton("question$choice[$number]","A",$off," ");
   	print $a_row[2]."<BR>\n";
   	&HTMLRadioButton("question$choice[$number]","B",$off," ");
   	print $a_row[3]."<BR>\n";
   	&HTMLRadioButton("question$choice[$number]","C",$off," ");
   	print $a_row[4]."<BR>\n";
   	&HTMLRadioButton("question$choice[$number]","D",$off," ");
   	print $a_row[5]."<BR>\n";
   	print "<BR>\n";
   	
#select the picture for this question.  There could be two pictures for the question
	$qry = "SELECT DISTINCT PICTURE_PATH ".
 	"from QUESTION_POOL Q,PICTURE P2,PICTURE_USED P1 WHERE ".
	"(P1.Q_NO=$a_row[0]) AND (P1.Picture_Number=P2.Picture_Number)";
	#print "About to send query \"$qry\" to database<BR>\n";
	$did=$oradb->SQL_OpenQuery($qry) or $oradb->SQL_Error && die "query failed";
	while ( @b_row = $oradb->SQL_FetchRow($did) )
	{
   		print "<IMG SRC=http://www.umr.edu/~traxdev/pics/$b_row[0]>";
#  		print "<BR>\n";
  		print "&nbsp;&nbsp;\n";
	}

 	print "<BR><BR>\n";

  	$number=$number+1;
  	$owner = $oradb->SQL_QuoteString($a_row[7]);
 	}
   print "</OL>\n";

# 	$qry = "SELECT EMAIL from TEACHER Where USER_ID = $owner";

# 	print "About to send query \"$qry\" to database<BR>\n";

#$cid=$oradb->SQL_OpenQuery($qry) or $oradb->SQL_Error && die "query failed";
# 	while ( @a_row = $oradb->SQL_FetchRow($cid) )
# 	{
#  	$email = $a_row[0];
# 	}

# 	$oradb->SQL_CloseQuery($cid);
# 	print "\n";

 	&HTMLHidden("no_quest",$number-1);
        print "\n";
# 	&HTMLHidden("email_add",$email);
#        print "\n";
# 	&HTMLHidden("username",$username);
#        print "\n";
 	&HTMLHidden("teachername",$teachname);
        print "\n";
 	&HTMLHidden("subject",$arg_subject);
        print "\n";
 	&HTMLSubmit("End Test");
        print "\n";
 	&HTMLEndForm;
        print "\n";
	} else 
  	{
	print "You have already taken the test, Talk to your teacher ";
	print "about retaking the test\n";
	}
 display_HTML_footer();
}

#----------------------------------------
# Do a review of the test.  This script
# just shows the questions and the correct
# answer for those questions that the 
# student went wrong.  It also makes
# a record in the exam_record table
# whether the student passed or failed
#----------------------------------------
if ($mode eq "review_test")
{
 get_cookies();
 $username=$cookies{"geometry_username"};
 $password=$cookies{"geometry_password"};

 get_oracle_auth();
  
 $oradb = new UMR::OracleObject;

 unless ($oradb->SQL_OpenDatabase ($tnsname, %orainfo))
 {
  &HTMLContentType;
  display_HTML_header($title);
  $oradb->SQL_Error ("Can't open database");
  display_HTML_footer();
  exit;
 }

 $is_student=is_student($username,$password);
 if ($is_student ne 1)
 {
  $is_teacher=is_teacher($username,$password);
  if ($is_teacher ne 1)
  {
   &HTMLContentType;
   display_HTML_header($title);
   print "Invalid login.<BR>\n";
   display_HTML_footer();
   exit;
  }
 }

# $arg_subject=$ARGV[0];
# $subject=$arg_subject;
# $title="$subject Test";


# $username=$rqpairs{"username"};
# chomp($username);
 $subject=$rqpairs{"subject"};
 chomp($subject);
 $teachname=$rqpairs{"teachername"};
# $email=$rqpairs{"email_add"};
# chomp($email);

 $quoted_username = $oradb->SQL_QuoteString($username);
 $quoted_subject = $oradb->SQL_QuoteString($subject);
 $quoted_teachname = $oradb->SQL_QuoteString($teachname);

 $title="Review $subject Test";
 &HTMLContentType;
 display_HTML_header($title);

 print "This is the Test review section.<BR>\n";
 print "You will be shown the correct answers for the questions you answered incorrectly";
 print "<BR>\n";
 if ($is_student eq 1)
 {
  print "An e-mail will be sent to your teacher if you passed.";
#  print "When you end this section, an e-mail will be sent to your teacher if you";
#  print "passed.  So it is in your interest to click the End button";
  print "<BR><BR>\n"; 
 }
#  $oradb->SQL_OpenDatabase ($tnsname, %orainfo) ||
#  $oradb->SQL_Error ("Can't open database");

  
 $qry = "SELECT DISTINCT Q_NO,QUESTION,ANSWER_1,ANSWER_2,ANSWER_3,ANSWER_4,".
 "CORRECT_NUMBER,OWNER from TEST T, QUESTION_POOL Where ((T.SUBJECT = $quoted_subject) ".
 "AND (T.T_USER_ID = $quoted_teachname) AND ((Q_NO=Q5) OR (Q_NO=Q4) OR (Q_NO=Q3) OR (Q_NO=Q2) OR (Q_NO=Q1)))";
# print "About to send query \"$qry\" to database<BR>\n";

 $cid=$oradb->SQL_OpenQuery($qry) or $oradb->SQL_Error && die "query failed";

# &HTMLStartForm(&HTMLScriptURL);
# print "\n";
# &HTMLHidden("mode","mark_test");
 $number=1;
 $result ="pass";
 print "<OL>\n";
  while ( @a_row = $oradb->SQL_FetchRow($cid) ) 
 {
  $questans = $rqpairs{"question$number"};
#  %correctans ={'A',0,'B',0,'C',0,'D',0};
  %correctans =('A',0,'B',0,'C',0,'D',0);
  $correctans{$a_row[6]}=1;

  print "<LI>";
  print $a_row[1];
  print "<TABLE>\n";

  print "<TR><TD>";
  if ($questans eq "A")
  {
#   print "&#183;";
   print "*";
  }
  else
  {
   print "&nbsp;";
  }
  print "</TD><TD>".$a_row[2]."</TD></TR>\n";

  print "<TR><TD>";
  if ($questans eq "B")
  {
   print "*";
#   print "&#183;";
  }
  else
  {
   print "&nbsp;";
  }
  print "</TD><TD>".$a_row[3]."</TD></TR>\n";

  print "<TR><TD>";
  if ($questans eq "C")
  {
   print "*";
#   print "&#183;";
  }
  else
  {
   print "&nbsp;";
  }
  print "</TD><TD>".$a_row[4]."</TD></TR>\n";

  print "<TR><TD>";
  if ($questans eq "D")
  {
   print "*";
#   print "&#183;";
  }
  else
  {
   print "&nbsp;";
  }
  print "</TD><TD>".$a_row[5]."</TD></TR>\n";

  print "</TABLE>\n";
#   print "<BR>\n";
#   &HTMLRadioButton("$number","a",$correctans{'A'}," ");
#   print $a_row[2]." ";
#   &HTMLRadioButton("$number","b",$correctans{'B'}," ");
#   print $a_row[3]." ";
#   &HTMLRadioButton("$number","c",$correctans{'C'}," ");
#   print $a_row[4]." ";
#   &HTMLRadioButton("$number","d",$correctans{'D'}," ");
#   print $a_row[5]." ";
#   print "<BR>\n";


  print "<BR>\n";
  if ($questans eq $a_row[6]) 
  {
   print "Correct.<BR>\n";
# Correct Answer
  } else 
  {
   print "The Correct Answer is ".$a_row[6]."<BR>\n";
   
#   print "<BR>\n";
#   &HTMLRadioButton("$number","a",$correctans{'A'}," ");
#   print $a_row[2]." ";
#   &HTMLRadioButton("$number","b",$correctans{'B'}," ");
#   print $a_row[3]." ";
#   &HTMLRadioButton("$number","c",$correctans{'C'}," ");
#   print $a_row[4]." ";
#   &HTMLRadioButton("$number","d",$correctans{'D'}," ");
#   print $a_row[5]." ";
#   print "<BR>\n";
   $result="fail";   
  }
  print "<BR><BR>\n";
  $number=$number+1;
 }
 print "</OL>\n";
 $oradb->SQL_CloseQuery($cid);

 $quoted_result = $oradb->SQL_QuoteString($result);
 #updating of exam_record goes here.
# $qry="UPDATE EXAM_RECORD set TEST_STATUS = $quoted_result ".
 $qry="UPDATE EXAM_RECORD set TEST_STATUS = $quoted_result, ".
      "DATE_TEST=sysdate ".
      "Where (S_USER_ID = $quoted_username) AND ".
      "(SUBJECT=$quoted_subject)";
# print "About to send query \"$qry\" to database<BR>\n";
 $cid=$oradb->SQL_OpenQuery($qry) or $oradb->SQL_Error && die "query failed";
 $oradb->SQL_CloseQuery($cid);

 print "\n";
# &HTMLHidden("no_quest",$number-1);
# &HTMLHidden("result",$result);
# &HTMLHidden("email_add",$email);
# &HTMLHidden("username",$username);
# &HTMLHidden("teachername",$teachname);
# &HTMLSubmit("End Test");
# &HTMLEndForm;

 if ($is_student eq 1)
 {
 	$qry = "SELECT EMAIL from TEACHER Where USER_ID = $quoted_teachname";

# 	print "About to send query \"$qry\" to database<BR>\n";

$cid=$oradb->SQL_OpenQuery($qry) or $oradb->SQL_Error && die "query failed";
 	while ( @a_row = $oradb->SQL_FetchRow($cid) )
 	{
   	 $email = $a_row[0];
 	}

 	$oradb->SQL_CloseQuery($cid);
 	print "\n";


  if ($result eq "pass")
  {
  	open (MAIL, "|$mailprog $email")
    	|| die "Unable to send email to Teacher\Take test again later, " .
    "Thank you</HTML>\n";
  	print MAIL "Subject: Test results\n";
  	print MAIL "\n\n";
  
  	print MAIL "user:$username\n";
  	$noquest = $rqpairs{"no_quest"};
   
  	for ($i=1;$i<=$noquest;$i++)
   {
   	 $questans = $rqpairs{"$i"};
    	 print MAIL "Question no.,$i,Answer,$questans\n";
   }
   	print MAIL "---------- End of Form ----------\n";
   	close MAIL;
 	print "<BR><BR>\n";
  	print "You passed the test, An e-mail has been ";
  	print "sent to your teacher";
  }
  else
  {
	print "You failed the test. Talk to your teacher ";
	print "to retake the test";
  }
 }

 display_HTML_footer();
}

